'$NAME OLE-ActiveX *.ints Generator

'	intsOLEGenerator.vbs -  *.ints   Intellisence
'	 trdm 2005
'
': $Revision: 1.2 $
'
'  ,  trdm 2005 
'	trdm@mail333.com
'	ICQ 308-779-620
'
'       TLBINF32.DLL
'        6-    microsoft, 
'   :  ,     : 2 
' http://download.microsoft.com/download/vstudio60pro/doc/1/win98/en-us/tlbinf32.exe
' http://support.microsoft.com/default.aspx?scid=kb;en-us;224331

Dim FileNameProgIDDumped
Dim DataDir
Dim WSH
Dim FSO

DataDir = BinDir & "\Config\Intell"
FileNameProgIDDumped		= DataDir + "\ProgIDDumped.txt"			'  ,  -    

'      ProgID-
Private Function GetPathFromProgID ( ProgID )
	GetPathFromProgID = Null
	RKey = "HKCR\"+ProgID+"\CLSID\"
	dim PathFile
	Dim val
	PathFile = Null
	On Error Resume Next
	val = WSH.RegRead(RKey)
	if Not IsEmpty(val) Then
		RKey = "HKCR\CLSID\"+val+"\InprocServer32\"
		KeyVal = WSH.RegRead(RKey)
		if IsEmpty(KeyVal) Then
			RKey = "HKCR\CLSID\"+val+"\LocalServer\"
			KeyVal = WSH.RegRead(RKey)
			if IsEmpty(KeyVal) Then
				RKey = "HKCR\CLSID\"+val+"\LocalServer32\"
				KeyVal = WSH.RegRead(RKey)
			End IF
		End IF
		if Not IsEmpty(KeyVal) Then
			PathFile = KeyVal
		End IF
	Else
		DMessage "      " + RKey + "  : " + ProgID
	End IF
	if IsNull(PathFile) Then
		On Error goto 0
		Exit Function
	End IF
	GetPathFromProgID = PathFile
	On Error goto 0
End Function


'   -      ProgID
' ProgID =     ,   .
Function IsProgID( ProgID )
	nProgID = Trim(ProgID)
	'   	ProgID ....
	IsProgID = True
	For i=1 To Len (nProgID)
		Char = Mid (nProgID,i,1)
		ChKd = Asc(Char)
		if Not ((ChKd = Asc(".")) or ( (Asc("A")<=ChKd) And (Asc("Z")>=ChKd)) or ( (Asc("a")<=ChKd) And (Asc("z")>=ChKd))) Then
			IsProgID = False
			Exit Function
		End IF
	Next
	PathFile = GetPathFromProgID ( ProgID )
	If PathFile = Null Then
		IsProgID = False
		Exit Function
	End If
	IsProgID = True
End Function

'  nProgID   (BinDir+"\Config\Intell\ProgIDDumped.txt"),  ,
'  ,         .
Function ProgIDIsDumped( nProgID )
	ProgIDIsDumped = False
	FileName = FileNameProgIDDumped
	if fso.FileExists( FileName ) Then
		Set File0 = fso.GetFile( FileName )
		Set File = File0.OpenAsTextStream(1)
		if File0.Size > 0 Then
			TextStream = File.ReadAll()
			If InStr(1, lCase(TextStream), lcase(nProgID))>0 Then
				ProgIDIsDumped = True
			End IF
		End IF
		File.Close
	End IF
End Function



'    .
Class ITypeLib
	Public LibName ' 
	Public LibPath ' 
	Public Library ' (TypeLibInfo)
	Public DefaultInterfaseName '   
	Public ThisProgID 'ProgID 
	Public ThisProgIDForIntel 'ProgID ,   OtherTypesDefine:  Excel.Application>>excel_application

	Public LibraryIsLoad '      .

	Public DebugFlag ' 
	Public flOutNameAndTypeParameters '      (  )
	Public AllDumpInterfases '  .

	Public Dumper ' -
	
	Dim DataDir						' ,   *.ints 
	Dim FileNameTypesStructureExt	'        Intellisence "TypesStructureExt"
	Dim FileNameOtherTypesDefine	'        Intellisence "OtherTypesDefine"
	Dim FileNameProgIDDumped		'  ,  -    
	' - ,  ,   -   
	'     *.ints 

	Public TypeStr

	Public ErrorNumber				'    .


	Public TLITypeLibInfo
	Public TLIApplication

	Dim INVOKE_UNKNOWN
	Dim INVOKE_FUNC
	Dim INVOKE_PROPERTYGET
	Dim INVOKE_PROPERTYPUT
	Dim INVOKE_PROPERTYPUTREF
	Dim INVOKE_EVENTFUNC
	Dim INVOKE_CONST

	Dim VT_EMPTY
	Dim VT_NULL
	Dim VT_I2
	Dim VT_I4
	Dim VT_R4
	Dim VT_R8
	Dim VT_CY
	Dim VT_DATE
	Dim VT_BSTR
	Dim VT_DISPATCH
	Dim VT_ERROR
	Dim VT_BOOL
	Dim VT_VARIANT
	Dim VT_UNKNOWN
	Dim VT_DECIMAL
	Dim VT_I1
	Dim VT_UI1
	Dim VT_UI2
	Dim VT_UI4
	Dim VT_I8
	Dim VT_UI8
	Dim VT_INT
	Dim VT_UINT
	Dim VT_VOID
	Dim VT_HRESULT
	Dim VT_PTR
	Dim VT_SAFEARRAY
	Dim VT_CARRAY
	Dim VT_USERDEFINED
	Dim VT_LPSTR
	Dim VT_LPWSTR
	Dim VT_RECORD
	Dim VT_FILETIME
	Dim VT_BLOB
	Dim VT_STREAM
	Dim VT_STORAGE
	Dim VT_STREAMED_OBJECT
	Dim VT_STORED_OBJECT
	Dim VT_BLOB_OBJECT
	Dim VT_CF
	Dim VT_CLSID
	Dim VT_VECTOR
	Dim VT_ARRAY
	Dim VT_BYREF
	Dim VT_RESERVED

	Dim TKIND_ENUM
	Dim TKIND_RECORD
	Dim TKIND_MODULE
	Dim TKIND_INTERFACE
	Dim TKIND_DISPATCH
	Dim TKIND_COCLASS
	Dim TKIND_ALIAS
	Dim TKIND_UNION
	Dim TKIND_MAX



	'  
	' CreateObj -  ,   -  
	' ProgID - - 
	Function LoadLibrary( ProgID, CreateObj )
		LoadLibrary = False
		LibraryIsLoad = False
		if ProgIDIsDumped( ProgID ) Then
			Message "  " + ProgID + "  .     ,  : "+ProgID+"  : " + FileNameProgIDDumped
			Exit Function
		End If

		ThisProgID = ProgID

		'  -  .
		LibPath = GetPathFromProgID ( ProgID )
		if IsNull(LibPath) Then
			ErrorNumber = 1
			SaveDumpedProgID lCase(ThisProgID)
			Message "- " + ThisProgID + "            .", mExclamation
			Exit Function
		End IF
		LibPath = Replace(LibPath,"/automation","")
		LibPath = Trim(LibPath)

		if not FSO.FileExists(LibPath) Then
			ErrorNumber = 1
			SaveDumpedProgID lCase(ThisProgID)
			Message "- " + ThisProgID + " :" + LibPath	, mExclamation
			LibPath = Null
		End If
		If not IsNull(LibPath) then
			On Error Resume Next
			Set Library = TLIApplication.TypeLibInfoFromFile(LibPath)
			if Err.number = 0 Then
				If not IsNull(Library) And Not IsEmpty( Library ) Then
					LoadLibrary = true
				End if
			End if
			On Error Goto 0
		End if
		LoadLibrary = False


		StrQuestion = "!      """+ProgID+""""+vbCr+_
		"   Intellisence.     "+vbCr+_
		"       ."+vbCr+_
		"  ." + vbCr +_
		"?"
		Dim MyAnswer
		MyAnswer = MsgBox (StrQuestion, vbRetryCancel+vbQuestion, "OLE-ActiveX *.ints Generator")
		if MyAnswer = vbCancel Then
			LoadLibrary = False
			LibraryIsLoad = LoadLibrary
			StrQuestion = "  """+ProgID+"""  ?"+ vbCr+_
			"     ."

			MyAnswer = MsgBox (StrQuestion, vbYesNo+vbQuestion, "OLE-ActiveX *.ints Generator")
			if MyAnswer = vbYes Then
				SaveDumpedProgID lCase(ThisProgID)
				ErrorNumber = 1
			End If
			Exit Function
		End If

		'          
		'             .
		On Error Resume Next
		Set Obj = CreateObject(ProgID)
		if Err.number<>0 Then
			LoadLibrary = false
			LibraryIsLoad = false
			ErrorNumber = 1
			SaveDumpedProgID lCase(ThisProgID)
			Message " - " + ThisProgID + "    ", mExclamation
			On Error goto 0
			Exit Function
		End If
		On Error goto 0

		if not IsEmpty(Obj) Then
			On Error Resume Next
			Set DefaultInterfase = TLIApplication.InterfaceInfoFromObject(Obj)
			if Err.number<>0 Then
				LoadLibrary = false
				LibraryIsLoad = false
				ErrorNumber = 1
				SaveDumpedProgID lCase(ThisProgID)
				Message " - " + ThisProgID + "     ", mExclamation
				On Error goto 0
				Exit Function
			End If
			On Error goto 0

			if Not IsEmpty( DefaultInterfase ) Then
				On Error Resume Next
				LibPath = DefaultInterfase.Parent.ContainingFile
				Set Library = TLIApplication.TypeLibInfoFromFile(LibPath)
				DefaultInterfaseName = DefaultInterfase.Name
				LoadLibrary = true
				LibraryIsLoad = true
				if Err.number<>0 Then
					LoadLibrary = false
					LibraryIsLoad = false

					ErrorNumber = 1
					SaveDumpedProgID lCase(ThisProgID)
					Message " - " + ThisProgID + "    ..", mExclamation
					On Error goto 0
					Exit Function
				On Error goto 0
				End If
			On Error goto 0
			End IF
			Obj = Null
		End IF
		LibraryIsLoad = LoadLibrary
		
		' -> 
		Dumper.OnLibraryLoad ThisProgID
		
		SaveDumpedProgID lCase(ThisProgID)
	End Function

	'     .
	Public Sub DumpStringToFile (DumpString, FileName)
		if Not fso.FileExists( FileName ) Then
			Set File = fso.CreateTextFile( FileName, False)
		Else
			Set File0 = fso.GetFile( FileName )
			Set File = File0.OpenAsTextStream(1)
			if File0.Size > 0 Then
				TextStream = File.ReadAll()
				If InStr(1, lCase(TextStream), lcase(DumpString))>0 Then
					File.Close
					Exit Sub
				End IF
			End IF
			Set File = File0.OpenAsTextStream(8)

		End IF
		File.WriteLine DumpString
		File.Close
	End Sub

	'   ProgID,     *.ints
	'private '   , 
	Sub SaveDumpedProgID( DumpedProgID )
		DumpStringToFile DumpedProgID, FileNameProgIDDumped
	End Sub

	Private  Sub DMessage( mess )
		if DebugFlag Then
			Message mess
		End If
	End Sub

	function CheskClass() ' ,   ...
		CheskClass = true
		If IsEmpty(TLITypeLibInfo) Then
			CheskClass = false
		ElseIf IsEmpty(TLIApplication) Then
			CheskClass = false
		ElseIf IsEmpty(WSH) Then
			CheskClass = false
		End IF
	End Function

	Private Sub Class_Initialize
		LibName = null
		On Error Resume Next
		Set TLITypeLibInfo = CreateObject("TLI.TypeLibInfo")
		Set TLIApplication = CreateObject("TLI.TLIApplication")
		if Err.number<>0 then
			Message ": ITypeLib  , : TLBINF32.DLL      !"
		End If
		On Error Goto 0
		Set TypeStr = CreateObject("Scripting.Dictionary")
		Set AllDumpInterfases = CreateObject("Scripting.Dictionary")
		DefaultInterfase = Null
		DebugFlag = false
		flOutNameAndTypeParameters = False

		DataDir = BinDir & "\Config\Intell"
		FileNameTypesStructureExt	= DataDir + "\TypesStructureExt.txt"	'        Intellisence "TypesStructureExt"
		FileNameOtherTypesDefine	= DataDir + "\OtherTypesDefine.txt"		'        Intellisence "OtherTypesDefine"
		FileNameProgIDDumped		= DataDir + "\ProgIDDumped.txt"			'  ,  -    
		ErrorNumber = 0


		INVOKE_UNKNOWN = 0
		INVOKE_FUNC = 1
		INVOKE_PROPERTYGET = 2
		INVOKE_PROPERTYPUT = 4
		INVOKE_PROPERTYPUTREF = 8
		INVOKE_EVENTFUNC = 16
		INVOKE_CONST = 32

		VT_EMPTY = 0
		VT_NULL = 1
		VT_I2 = 2
		VT_I4 = 3
		VT_R4 = 4
		VT_R8 = 5
		VT_CY = 6
		VT_DATE = 7
		VT_BSTR = 8
		VT_DISPATCH = 9
		VT_ERROR = 10
		VT_BOOL = 11
		VT_VARIANT = 12
		VT_UNKNOWN = 13
		VT_DECIMAL = 14
		VT_I1 = 16
		VT_UI1 = 17
		VT_UI2 = 18
		VT_UI4 = 19
		VT_I8 = 20
		VT_UI8 = 21
		VT_INT = 22
		VT_UINT = 23
		VT_VOID = 24
		VT_HRESULT = 25
		VT_PTR = 26
		VT_SAFEARRAY = 27
		VT_CARRAY = 28
		VT_USERDEFINED = 29
		VT_LPSTR = 30
		VT_LPWSTR = 31
		VT_RECORD = 36
		VT_FILETIME = 64
		VT_BLOB = 65
		VT_STREAM = 66
		VT_STORAGE = 67
		VT_STREAMED_OBJECT = 68
		VT_STORED_OBJECT = 69
		VT_BLOB_OBJECT = 70
		VT_CF = 71
		VT_CLSID = 72
		VT_VECTOR = 4096
		VT_ARRAY = 8192
		VT_BYREF = 16384
		VT_RESERVED = 32768

		TypeStr.Add VT_EMPTY ,"VT_EMPTY"
		TypeStr.Add VT_NULL ,"VT_NULL"
		TypeStr.Add VT_I2 ," (VT_I2)"
		TypeStr.Add VT_I4 ," (VT_I4)"
		TypeStr.Add VT_R4 ," (VT_R4)"
		TypeStr.Add VT_R8  ," (VT_R8)"
		TypeStr.Add VT_CY ,"VT_CY"
		TypeStr.Add VT_DATE  ," (VT_DATE)"
		TypeStr.Add VT_BSTR ," (VT_BSTR)"
		TypeStr.Add VT_DISPATCH ,"VT_DISPATCH"
		TypeStr.Add VT_ERROR ,"VT_ERROR"
		TypeStr.Add VT_BOOL ," (VT_BOOL)"
		TypeStr.Add VT_VARIANT ,"VT_VARIANT"
		TypeStr.Add VT_UNKNOWN ,"VT_UNKNOWN"
		TypeStr.Add VT_DECIMAL ," (VT_DECIMAL)"
		TypeStr.Add VT_I1 ," (VT_I1)"
		TypeStr.Add VT_UI1 ," (VT_UI1)"
		TypeStr.Add VT_UI2 ," (VT_UI2)"
		TypeStr.Add VT_UI4 ," (VT_UI4)"
		TypeStr.Add VT_I8 ," (VT_I8)"
		TypeStr.Add VT_UI8 ," (VT_UI8)"
		TypeStr.Add VT_INT ," (VT_INT)"
		TypeStr.Add VT_UINT ," (VT_UINT)"
		TypeStr.Add VT_VOID,"VT_VOID"
		TypeStr.Add VT_HRESULT,"VT_HRESULT"
		TypeStr.Add VT_PTR,"VT_PTR"
		TypeStr.Add VT_SAFEARRAY ,"VT_SAFEARRAY"
		TypeStr.Add VT_CARRAY ,"VT_CARRAY"
		TypeStr.Add VT_USERDEFINED,"VT_USERDEFINED"
		TypeStr.Add VT_LPSTR,"VT_LPSTR"
		TypeStr.Add VT_LPWSTR,"VT_LPWSTR"
		TypeStr.Add VT_RECORD,"VT_RECORD"
		TypeStr.Add VT_FILETIME,"VT_FILETIME"
		TypeStr.Add VT_BLOB,"VT_BLOB"
		TypeStr.Add VT_STREAM,"VT_STREAM"
		TypeStr.Add VT_STORAGE,"VT_STORAGE"
		TypeStr.Add VT_STREAMED_OBJECT,"VT_STREAMED_OBJECT"
		TypeStr.Add VT_STORED_OBJECT,"VT_STORED_OBJECT"
		TypeStr.Add VT_BLOB_OBJECT,"VT_BLOB_OBJECT"
		TypeStr.Add VT_CF,"VT_CF"
		TypeStr.Add VT_CLSID,"VT_CLSID"
		TypeStr.Add VT_VECTOR,"VT_VECTOR"
		TypeStr.Add VT_ARRAY,"VT_ARRAY"
		TypeStr.Add VT_BYREF,"VT_BYREF"
		TypeStr.Add VT_RESERVED,"VT_RESERVED"

		TKIND_ENUM = 0
		TKIND_RECORD = 1
		TKIND_MODULE = 2
		TKIND_INTERFACE = 3
		TKIND_DISPATCH = 4
		TKIND_COCLASS = 5
		TKIND_ALIAS = 6
		TKIND_UNION = 7
		TKIND_MAX = 8


	End Sub

	Private Function OstDel(Pa1, Pa2)
		OstDel = Pa1 - ((Pa1\Pa2)*Pa2)
	End Function

	Private Sub Class_Terminate	' Setup Terminate event.
		TLITypeLibInfo = Null
		TLIApplication = Null
		DefaultInterfaseName = Null
		Set Dumper = Nothing
	End Sub

	Function AttrIsEnum ( InvokeKinds ) '   
		IsEnumAttr = False
		if OstDel(Fix(InvokeKinds/INVOKE_CONST),2) = 1 Then
			IsEnumAttr = True
		End IF
	End Function

	Function AttrIsEvent ( InvokeKinds ) '   
		AttrIsEvent = False
		if OstDel(Fix(InvokeKinds/INVOKE_EVENTFUNC),2) = 1 Then
			AttrIsEvent = True
		End IF
	End Function

	Function AttrIsFunc ( InvokeKinds ) '   
		AttrIsFunc = False
		if OstDel(Fix(InvokeKinds/INVOKE_FUNC),2) = 1 Then
			AttrIsFunc = True
		End IF
	End Function

	Function AttrIsProps ( InvokeKinds ) '   
		AttrIsProps = False
		if OstDel(Fix(InvokeKinds/INVOKE_PROPERTYGET),2) = 1 Then
			AttrIsProps = True
		Elseif OstDel(Fix(InvokeKinds/INVOKE_PROPERTYPUT),2) = 1 Then
			AttrIsProps = True
		Elseif OstDel(Fix(InvokeKinds/INVOKE_PROPERTYPUTREF),2) = 1 Then
			AttrIsProps = True
		End IF
	End Function


	Function GetObjectByName( InterfaseName )
		GetObjectByName = Null
		if IsObject(Library) Then
			set GetObjectByName = Library.Interfaces.NamedItem(""+ InterfaseName )
		End If
	End Function
	Function GetObjectDefault(  )
		GetObjectDefault = Null
		if IsObject(Library) Then
			set GetObjectDefault = Library.Interfaces.NamedItem(""+ DefaultInterfaseName )
		End If
	End Function

	' ( , ,=0, = )
	private Function NoMyMakeSearchData (TypeInfoNumber) ',127,0,false)
		NoMyMakeSearchData = 127 * 16777216 + (4096 +  TypeInfoNumber - 4096 * Fix(TypeInfoNumber/4096))
	end Function

	'  ,       ,
	'            
	'  NoMyMakeSearchData     (((,   )))  ......
	Function GetMemberOfObjectInfo ( Member, Object )
		GetMemberOfObjectInfo = null
		if IsObject( Member ) And IsObject( Object ) Then
			SearchData = NoMyMakeSearchData( Object.TypeInfoNumber )
			set GetMemberOfObjectInfo = Library.GetMemberInfo ( SearchData, Member.InvokeKinds,  Member.MemberId, Member.Name)
		End if
	end Function


	'       
	Function VarTypeToString ( VarType )
		VarTypeToString = ""
		If TypeStr.Exists( VarType ) Then
			VarTypeToString = TypeStr.Item( VarType )
		End If
	end Function

	'      ?
	Function ParamHaveDefValue ( Param )
		ParamHaveDefValue = False
		If Param.Default And Param.Optional Then
			ParamHaveDefValue = True
		End If
	end Function

	'   
	Function ParamIsBinding ( Param )
		ParamIsBinding = False
		If Param.Default Or Param.Optional Then
			ParamIsBinding = True
		End If
	end Function

	'     . DumpInterfaseObject
	Function InterfaseIsDump ( Name )
		InterfaseIsDump = AllDumpInterfases.Exists(Trim(LCase(Name)))
	end Function

	'    . DumpInterfaseObject
	Function InterfaseIsDumpMark ( Name )
		If Not InterfaseIsDump(Trim(LCase(Name))) Then
			AllDumpInterfases.Add Trim(LCase(Name)), Trim(LCase(Name))
		end if
	end Function

	'     
	Public Function GetParamTypeStr ( Param )
		ParamTipeStr = ""
		Set ParaVarTypeInfo = Param.VarTypeInfo
		ParaVarType  = ParaVarTypeInfo.VarType
		Fixed = Fix ( ParaVarType / 4096)
		FlagVT_ARRAY = OstDel(Fixed, 2)
		FlagVT_VECTOR = OstDel( Fix( Fixed / 2),2)
		TypeVars = Fix(Fixed/4)*4*4096+(ParaVarType - Fixed)
		If TypeVars = 0 Then ' .....
			TKind = Null
			Do '     
				On Error Resume Next
				set InfoOfType = ParaVarTypeInfo.TypeInfo
				set TIType =  ParaVarTypeInfo.TypeInfo

				TIResolved = ParaVarTypeInfo.TypeInfo
				'set TIResolved = ParaVarTypeInfo.TypeInfo
				TKind = TIResolved.TypeKind
				if Err.Number <> 0 Then
					TKind = ParaVarTypeInfo.TypeInfo.TypeKind
					on error goto 0
				End If
			Loop Until True
			While TKind = TKIND_ALIAS
				TKind = TKIND_MAX
				On Error Resume Next
				set TIResolved = TIResolved.ResolvedType
				TKind = TIResolved.TypeKind
				on error goto 0
			Wend

			If TKind = Null Then
				ParamTipeStr = "?"
			else
				IF ParaVarTypeInfo.IsExternalType Then
					ParamTipeStr = ParaVarTypeInfo.TypeLibInfoExternal.Name+"."+TIType.Name
				Else
					ParamTipeStr = TIType.Name
				End If
			End If

		Else
			If ParaVarTypeInfo.VarType <> VT_VARIANT Then
				ParamTipeStr = VarTypeToString(Param.VarTypeInfo.VarType)
			Else
				ParamTipeStr = "VT_VARIANT"
			End IF

		End If
		If IsEmpty( ParamTipeStr ) Or (ParamTipeStr = "")  Then
			if Param.VarTypeInfo.TypeInfoNumber <> -1 Then
				ParamTipeStr = Param.VarTypeInfo.TypeInfo.TypeKindString
			else
				ParamTipeStr = VarTypeToString(Param.VarTypeInfo.VarType)
			End IF
		End IF
		GetParamTypeStr = ParamTipeStr
	end Function

	'     
	'        -,     -.
	Public Function MakeIName( iName )
		nMakeIName = lcase(iName)
		If nMakeIName = LCase(DefaultInterfaseName) Then nMakeIName = ""
		MakeIName = Replace(LCase(ThisProgID), ".", "_") + nMakeIName
	end Function

	'       ...
	'         ...
	' Name -  
	' AllStrIterf -     
	Sub DumpInterfaseObject ( Name , AllStrIterf)

		FindInterfases = "" '  " " ...
		
		On Error Resume Next
		Set Object 		= GetObjectByName( "" + Name )
		Set TrueMembers = Object.Members.GetFilteredMembers
		IF Err.Number <> 0 Then
			On Error GoTo 0
			Exit Sub
		End If

		' -> 
		Dumper.OnInterfaceBegin Name
		
		For i=1 To TrueMembers.Count
		
			Set Member = TrueMembers.item(i)
			Set MemberInfo = GetMemberOfObjectInfo ( Member, Object )

			MemberIK = Member.InvokeKinds
			
			If AttrIsProps( MemberIK) Then 'INVOKE_EVENTFUNC  
			
				If MemberInfo.ReturnType.TypeInfoNumber <> -1 Then
					If MemberInfo.ReturnType.TypeInfo.TypeKindString = "coclass" Then
						'   ,   
						FindInterfases = FindInterfases + vbCrLf + MemberInfo.ReturnType.TypeInfo.DefaultInterface.Name
					ElseIf MemberInfo.ReturnType.TypeInfo.TypeKindString = "dispinterface" Then
						FindInterfases = FindInterfases + vbCrLf + MemberInfo.ReturnType.TypeInfo.Name
					End If
				End If
				
				' -> 
				Dumper.OnProperty Name, MemberInfo 
				
			ElseIf AttrIsFunc ( MemberIK) Then 'INVOKE_FUNC  /
				
				'   ....
				StrForMessage = ""
				If MemberInfo.ReturnType.TypeInfoNumber = -1 Then
					StrForMessage = " meth - " + Member.Name
				Else
					StrForMessage = " func - " + Member.Name
				End If
				
				' -> 
				Dumper.OnMethodBegin Name, MemberInfo
								
				For ParCnt = 1 To MemberInfo.Parameters.Count
					Set Param = MemberInfo.Parameters.Item(ParCnt)
					
					' -> 
					Dumper.OnMethodParam Name, MemberInfo.Name, Param
					
					' Param.Default = true ->     = 
					If flOutNameAndTypeParameters Then
						If Param.Default Then StrForMessage = StrForMessage + "["
						StrForMessage = StrForMessage + Param.Name + " as " + GetParamTypeStr ( Param )
						If Param.Default Then StrForMessage = StrForMessage + "]"
					End If
					If ParCnt <> MemberInfo.Parameters.Count Then StrForMessage = StrForMessage + ", "
					StrForMessage = Replace(StrForMessage," ","") '  
				Next

				StrForMessage = StrForMessage + ")"

				'     
				If MemberInfo.ReturnType.TypeInfoNumber <> -1 Then
					If MemberInfo.ReturnType.TypeInfo.TypeKindString = "dispinterface" Then
						FindInterfases = FindInterfases + vbCrLf + MemberInfo.ReturnType.TypeInfo.Name
						StrForMessage = StrForMessage + " as Interfase " + MemberInfo.ReturnType.TypeInfo.Name
					ElseIf MemberInfo.ReturnType.TypeInfo.TypeKindString = "coclass" Then
						FindInterfases = FindInterfases + vbCrLf + MemberInfo.ReturnType.TypeInfo.DefaultInterface.Name
						FindInterfases = FindInterfases + vbCrLf + MemberInfo.ReturnType.TypeInfo.DefaultEventInterface.Name
					End If
				End If
				'if MemberInfo.HelpString <> "" Then StrForMessage = StrForMessage + " Help -> " + MemberInfo.HelpString
				'Message StrForMessage
				
				' -> 
				Dumper.OnMethodEnd Name, MemberInfo
				
			End IF
		Next

		'    
		InterfaseIsDumpMark(Name)

		' -> 
		Dumper.OnInterfaceEnd Name

		ArrNameOfIntrf = Split(FindInterfases, vbcrlf)
		for i=0 To UBound(ArrNameOfIntrf)
			iName = trim(ArrNameOfIntrf(i))
			if iName <> "" Then
				if Not InterfaseIsDump(iName) Then
					DumpInterfaseObject iName, AllStrIterf + "." + Name
				End IF
			End IF
		next
	End Sub
	
End class 'ITypeLib

' ================================================================
'  - -    
'      (    
'      )
'
Class SimpleDumper

	Private Processor '   ITypeLib (     )

	Private MethStr '  ,    
					'     
				
	Private Sub Class_Initialize()
	End Sub

	Private Sub Class_Terminate()
		' !!! ,   - Dumper <-> ITypeLib 
		'       
		Set Processor = Nothing
	End Sub

	' Setup(ProcessorObject)
	'	  
	' :
	'	ProcessorObject -    ITypeLib
	'
	Public Sub Setup(ProcessorObject)
		Set Processor = ProcessorObject
	End Sub

	' OnLibraryLoad(ProgID)
	'	
	' :
	'	ProgID - , progid 
	'
	Public Sub OnLibraryLoad(ProgID)
		Message "---- Dumping library " + ProgId + "... -----------------------"
	End Sub
	
	' OnInterfaceBegin(Name)
	' 	  
	' 
	' 	Name - ,  
	'
	Public Sub OnInterfaceBegin(Name)
		Message "---> " + Name
	End Sub

	' OnInterfaceEnd(Name)
	'	  
	' 
	' 	Name - ,  
	'
	Public Sub OnInterfaceEnd(Name)
		Message "<--- " + Name
	End Sub
	
	' OnProperty(IName, Prop)
	'	  
	' :
	'	IName	-   
	'	Prop	- MemberInfo, ,    
	'
	Public Sub OnProperty(IName, Prop)
		Message "Property " + Prop.Name
	End Sub
	
	' OnMethodBegin(IName, Meth)
	'	  
	' :
	'	IName	-   	
	'	Meth 	- MemberInfo, ,    
	'
	Public Sub OnMethodBegin(IName, Meth)
		MethStr = Meth.Name + "("
	End Sub

	' OnMethodEnd(IName, Meth)
	'	  
	' :
	'	IName	-   	
	'	Meth 	- MemberInfo, ,    
	'
	Public Sub OnMethodEnd(IName, Meth)
		Message "Method " + MethStr + ")"
	End Sub

	' OnMethodParam(IName, MName, Param)
	'	  
	' :
	'	IName	-   	
	'	MName	-   
	'	Param	- ParameterInfo, ,     
	'
	Public Sub OnMethodParam(IName, MName, Param)		
		If Right(MethStr, 1) = "(" Then 
			MethStr = MethStr + Param.Name
		Else
			MethStr = MethStr + "," + Param.Name
		End If
	End Sub

	' Finalize()
	' 
	Public Sub Finalize()
	End Sub
	
End Class ' SimpleDumper


' ================================================================
'       *.ints
'
Class IntsDumper

	Private Processor '   ITypeLib (     )

	Private MethStr '  ,    
					'     

	Private DataDir						' <BinDir>\Config\Intell
	Private TypesStructureExtFileName	'         Intellisence "TypesStructureExt"
	Private OtherTypesDefineFileName	'        Intellisence "OtherTypesDefine"
	
	Private IntsFile '  *.ints-
				
	Private Sub Class_Initialize()
		DataDir = fso.BuildPath(BinDir, "\Config\IntellTest")
		TypesStructureExtFileName	= fso.BuildPath(DataDir, "TypesStructureExt.txt")
		OtherTypesDefineFileName	= fso.BuildPath(DataDir, "OtherTypesDefine.txt")
	End Sub

	Private Sub Class_Terminate()
		' !!! ,   - Dumper <-> ITypeLib 
		'       
		Set Processor = Nothing
		Status "" '   
	End Sub

	' Setup(ProcessorObject)
	'	  
	' :
	'	ProcessorObject -    ITypeLib
	'
	Public Sub Setup(ProcessorObject)
		Set Processor = ProcessorObject
	End Sub

	'      Intellisence "TypesStructureExt"
	Private Sub SaveForTypesStructureExt (Interf1, FuncPropName, Interf2)
		SaveStr = Processor.MakeIName(CStr(Interf1))+ "." + Lcase(FuncPropName)+"," + "VALUE|"+Processor.MakeIName(CStr(Interf2))
		Processor.DumpStringToFile SaveStr, TypesStructureExtFileName
	End Sub
	
	' OnLibraryLoad(ProgID)
	'	
	' :
	'	ProgID - , progid 
	'
	Public Sub OnLibraryLoad(ProgID)
		ProgIDForIntell = Replace(LCase(ProgID), ".", "_")
		Processor.DumpStringToFile LCase(ProgID) + "," + ProgIDForIntell, OtherTypesDefineFileName
	End Sub
	
	' OnInterfaceBegin(Name)
	' 	  
	' 
	' 	Name - ,  
	'
	Public Sub OnInterfaceBegin(Name)
		IntsFileName = fso.BuildPath(DataDir, Processor.MakeIName(Name) + ".ints")
		if fso.FileExists(IntsFileName) Then fso.DeleteFile IntsFileName, true		
		Set IntsFile = fso.CreateTextFile(IntsFileName)
		Status " : " + IntsFileName
	End Sub

	' OnInterfaceEnd(Name)
	'	  
	' 
	' 	Name - ,  
	'
	Public Sub OnInterfaceEnd(Name)
		IntsFile.Close	
	End Sub
	
	' OnProperty(IName, Prop)
	'	  
	' :
	'	IName	-   
	'	Prop	- MemberInfo, ,    
	'
	Public Sub OnProperty(IName, Prop)
		If Prop.ReturnType.TypeInfoNumber <> -1 Then
			If Prop.ReturnType.TypeInfo.TypeKindString = "coclass" Then
				'   ,   
				SaveForTypesStructureExt IName, Prop.Name, Prop.ReturnType.TypeInfo.DefaultInterface.Name
			ElseIf Prop.ReturnType.TypeInfo.TypeKindString = "dispinterface" Then
				SaveForTypesStructureExt IName, Prop.Name, Prop.ReturnType.TypeInfo.Name
			End If
		End If
		IntsFile.WriteLine "0000 " + Prop.Name
	End Sub
	
	' OnMethodBegin(IName, Meth)
	'	  
	' :
	'	IName	-   	
	'	Meth 	- MemberInfo, ,    
	'
	Public Sub OnMethodBegin(IName, Meth)
		MethStr = Meth.Name + "("
	End Sub

	' OnMethodEnd(IName, Meth)
	'	  
	' :
	'	IName	-   	
	'	Meth 	- MemberInfo, ,    
	'
	Public Sub OnMethodEnd(IName, Meth)
		'     
		If Meth.ReturnType.TypeInfoNumber <> -1 Then
			If Meth.ReturnType.TypeInfo.TypeKindString = "dispinterface" Then
				SaveForTypesStructureExt IName, Meth.Name, Meth.ReturnType.TypeInfo.Name
			ElseIf Meth.ReturnType.TypeInfo.TypeKindString = "coclass" Then
				SaveForTypesStructureExt IName, Meth.Name, Meth.ReturnType.TypeInfo.DefaultInterface.Name
				SaveForTypesStructureExt IName, Meth.Name, Meth.ReturnType.TypeInfo.DefaultEventInterface.Name
			End If
		End If		
		MethStr = Replace(MethStr, " ", "") + ")"
		IntsFile.WriteLine "0000 " + MethStr
	End Sub

	' OnMethodParam(IName, MName, Param)
	'	  
	' :
	'	IName	-   	
	'	MName	-   
	'	Param	- ParameterInfo, ,     
	'
	Public Sub OnMethodParam(IName, MName, Param)		
		If Right(MethStr, 1) = "(" Then 
			MethStr = MethStr + "f"
		Else
			MethStr = MethStr + ",f"
		End If
	End Sub

	' Finalize()
	' 
	Public Sub Finalize()
	End Sub
	
End Class ' IntsDumper

' ================================================================
'    XML-,    *.tls
'     2.
'
Class XMLDumper

	Private Processor '   ITypeLib (     )
	
	Private DataDir
	
	Private XMLDoc
	Private RootElement '   Types
	Private CurInterface '    Type
	Private CurProps '    attribs
	Private CurMeths '    methods
	Private CurMeth '    method
	Private CurMethParams '    params
	
	Private LibraryProgId
	Private XMLFileName '    
	
	Private Sub Class_Initialize()
		DataDir = fso.BuildPath(BinDir, "Config\system\xml2tls")
		Set XMLDoc = CreateObject("MSXML2.DOMDocument")
		XMLDoc.async = False
		XMLDoc.resolveExternals = False	
		Set pi = XMLDoc.createProcessingInstruction("xml", _ 
			"version='1.0' encoding='windows-1251'")
		XMLDoc.appendChild pi
		Set RootElement = XMLDoc.createElement("Types")
		XMLDoc.appendChild(RootElement)
	End Sub

	Private Sub Class_Terminate()
		Set CurProps = Nothing
		Set CurMethParams = Nothing
		Set CurMeth = Nothing
		Set CurMeths = Nothing
		Set CurInterface = Nothing
		Set RootElement = Nothing
		Set XMLDoc = Nothing
		' !!! ,   - Dumper <-> ITypeLib 
		'       
		Set Processor = Nothing
	End Sub

	' Setup(ProcessorObject)
	'	  
	' :
	'	ProcessorObject -    ITypeLib
	'
	Public Sub Setup(ProcessorObject)
		Set Processor = ProcessorObject
	End Sub

	' OnLibraryLoad(ProgID)
	'	
	' :
	'	ProgID - , progid 
	'
	Public Sub OnLibraryLoad(ProgID)
		LibraryProgId = ProgID
		XMLFileName = fso.BuildPath(DataDir, ProgId + ".xml")
	End Sub
	
	' OnInterfaceBegin(Name)
	' 	  
	' 
	' 	Name - ,  
	'
	Public Sub OnInterfaceBegin(Name)		
		Set CurInterface 	= XMLDoc.createElement("Type")
		Set CurProps 		= XMLDoc.createElement("attribs")
		Set CurMeths		= XMLDoc.createElement("methods")		
		CurInterface.setAttribute "name", Processor.MakeIName(Name)
		CurInterface.setAttribute "alias", Name
		' XXX   /  /  ,   
		'     (,    ,  ?)
		'    creatable     -
		If LCase(Replace(Name,".",".")) = Processor.MakeIName(Name) Then
			CurInterface.setAttribute "creatable", LibraryProgId			
		End If		
	End Sub

	' OnInterfaceEnd(Name)
	'	  
	' 
	' 	Name - ,  
	'
	Public Sub OnInterfaceEnd(Name)		
		If CurProps.hasChildNodes() Then CurInterface.appendChild(CurProps)
		If CurMeths.hasChildNodes() Then CurInterface.appendChild(CurMeths)
		RootElement.appendChild(CurInterface)		
	End Sub
	
	' OnProperty(IName, Prop)
	'	  
	' :
	'	IName	-   
	'	Prop	- MemberInfo, ,    
	'
	Public Sub OnProperty(IName, Prop)		
		Set Attrib = XMLDoc.createElement("attrib")		
		Attrib.setAttribute "name", Prop.Name
		Attrib.setAttribute "alias", Prop.Name
		Attrib.setAttribute "type", Prop.ReturnType.TypeInfo.Name
		If Prop.HelpString <> "" Then
			Set Descr = XMLDoc.createTextNode(Prop.HelpString)
			Attrib.appendChild(Descr)
		End If		
		CurProps.appendChild(Attrib)		
	End Sub
	
	' OnMethodBegin(IName, Meth)
	'	  
	' :
	'	IName	-   	
	'	Meth 	- MemberInfo, ,    
	'
	Public Sub OnMethodBegin(IName, Meth)		
		Set CurMeth = XMLDoc.createElement("method")
		CurMeth.setAttribute "name", Meth.Name
		CurMeth.setAttribute "alias", Meth.Name
		If Meth.HelpString <> "" Then
			Set Descr = XMLDoc.createTextNode(Meth.HelpString)
			CurMeth.appendChild(Descr)
		End If		
		Set CurMethParams = XMLDoc.createElement("params")		
	End Sub

	' OnMethodEnd(IName, Meth)
	'	  
	' :
	'	IName	-   	
	'	Meth 	- MemberInfo, ,    
	'
	Public Sub OnMethodEnd(IName, Meth)	
		If CurMethParams.hasChildNodes() Then CurMeth.appendChild(CurMethParams)
		' XXX  -,     ...
		'  ,       ,
		'     :-(
		'If Not (IsEmpty(Meth.ReturnType) or IsEmpty(Meth.ReturnType.TypeInfo))Then
		'	Set ReturnType = XMLDoc.createElement("return")
		'	ReturnType.setAttribute "type", Meth.ReturnType.TypeInfo.Name
		''	Set Descr = XMLDoc.createTextNode(Meth.ReturnType.TypeInfo.Name)
		'	ReturnType.appendChild(Descr)
		'	CurMeth.appendChild(ReturnType)
		'End If
		CurMeths.appendChild(CurMeth)
	End Sub

	' OnMethodParam(IName, MName, Param)
	'	  
	' :
	'	IName	-   	
	'	MName	-   
	'	Param	- ParameterInfo, ,     
	'
	Public Sub OnMethodParam(IName, MName, Param)
		Set MethParam = XMLDoc.createElement("param")
		MethParam.setAttribute "name", Param.Name
		MethParam.setAttribute "type", Processor.GetParamTypeStr(Param)
		If Param.Default Then
			' XXX
			MethParam.setAttribute "default", CStr(Param.DefaultValue) 
		End If
		CurMethParams.appendChild(MethParam)
	End Sub
	
	' Finalize()
	' 
	Public Sub Finalize()
		' XXX    (. js-  , xml_indent)
		XMLDoc.save(XMLFileName)		
	End Sub
	
End Class ' XMLDumper

' 
Function IntsGenerator( ProgID )
'Stop
	IntsGenerator = False
	if not IsProgID( ProgID )  Then Exit Function
	if ProgIDIsDumped( ProgID ) Then Exit Function
	
	Set li = new ITypeLib
	
	Set Dumper = New XMLDumper
	Dumper.Setup(li)
	
	Set li.Dumper = Dumper
	
	li.DebugFlag = true
	li.flOutNameAndTypeParameters = false
	if li.LoadLibrary( ProgId , True) Then
		IntsGenerator = True
		message "######################################################################"
		message ": " + li.LibPath + "   -: " + li.ThisProgID
		Message "  :" + li.DefaultInterfaseName
		AllStrIterf = ""
		li.DumpInterfaseObject  li.DefaultInterfaseName , AllStrIterf
		Message "  : " + ProgID
		message "######################################################################"

		Dumper.Finalize()
		
	ElseIF li.ErrorNumber<>0 Then
		message "    -: " + li.ThisProgID, mExclamation
	End IF
End Function

'  *.ints-   -
'Sub Generator()
'	ProgID = ""
'	ProgID = InputBox (" ProgID", "OLE-ActiveX *.ints Generator",ProgID)
'	ProgID = Trim(ProgID)
'	If Len(ProgID)>0 Then
'		if IntsGenerator( ProgID ) Then
'			Scripts("Intellisence").ReloadDictionary
'		End If
'	End IF
'End Sub

'        ,
'  -,     ,
'          
' *.ints-,     ProgIDDumped.txt   
'      .
'
'         .
'        .
Sub ReGenerator()
	If FSO.FileExists(FileNameProgIDDumped) Then
		Set File0 = fso.GetFile( FileNameProgIDDumped )
		Set File = File0.OpenAsTextStream(1)
		if File0.Size > 0 Then
			TextStream = File.ReadAll()
			Set ch = CreateObject("svcsvc.service")
			needProgID = ch.SelectValue(TextStream,"  ")
			File.Close
			if Len(needProgID)>0 Then
				fso.DeleteFile  FileNameProgIDDumped, true
				Set File = fso.CreateTextFile(FileNameProgIDDumped)

				AllProgID = Split(TextStream, vbCrLf)
				for i=0 To UBound (AllProgID)
					if needProgID<>AllProgID(i) And Len(Trim(AllProgID(i)))>0 Then
						File.WriteLine AllProgID(i)
					End If
				Next
				File.Close
				if IntsGenerator( needProgID ) Then
					Scripts("Intellisence").ReloadDictionary
				End If

			End If
		Else
			File.Close
			Message ": " + FileNameProgIDDumped + " !", mExclamation
			Exit Sub
		End IF
	Else
		Message ": " + FileNameProgIDDumped + "  !", mExclamation
	End IF
End Sub


'    :
'1. ints-   
'2.  TypesStructureExt  Intellisence     
'	TypesStructureExt.Add "excel_application.range", "VALUE|excel_applicationrange"
'	TypesStructureExt.Add "excel_applicationrange.cells", "VALUE|excel_applicationcells"
'3  OtherTypesDefine   Intellisence     
'	OtherTypesDefine.Add "word.application", "word_application"
'4  -           
'  , - ,  ,   -   .

Sub CommonGenerator( )

	IntsGenerator( "Scripting.FileSystemObject")
	'IntsGenerator( "ADODB.Connection" )
	'IntsGenerator( "WScript.Shell" )
	'IntsGenerator( "MSXML2.DOMDocument" )

Exit sub '   .......
	IntsGenerator( "Excel.Application" )
	IntsGenerator( "Word.application" )
	IntsGenerator( "SYSINFO.SysInfo" )
	IntsGenerator( "Svcsvc.Service" )
	IntsGenerator( "v77.Application" )
	IntsGenerator( "VBScript.RegExp" ) '     ((((  ....
	IntsGenerator( "SHPCE.Profiler" )
	IntsGenerator( "ODBCSQL.RarusSQL" )
	IntsGenerator( "TLI.TypeLibInfo" )
	IntsGenerator( "TLI.TLIApplication" )
	IntsGenerator( "Rarus.ApiExtender" )
End Sub

Sub TestLibrary()
	On Error Resume Next
	Set TLITypeLibInfo = CreateObject("TLI.TypeLibInfo")
	Set TLIApplication = CreateObject("TLI.TLIApplication")
	if Err.number<>0 then
		Message ": TLBINF32.DLL      !"
	Else
		Message ": TLBINF32.DLL !   !"
	End If
	On Error Goto 0
End Sub
' ....
Sub InitScript( para )
	set WSH = CreateObject("WScript.Shell")
	Set FSO = CreateObject("Scripting.FileSystemObject")
End Sub

InitScript 0
